
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//               ProgramName:   UCDAs.eXe
//               Used for:
//               Compiler:      Turbo_Pascal 6.0
//               CopyRigth by:  Thomas Pantzer
//                              Kurt Tucholskistr.8
//                              O-7030  Leipzig
//               Date:          8.3.1993
//_____________________________________________________________________________


static uchar configIndex1 = 'T';

//~~~~~~~~~~~~~~~~~~ begin config~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

static uchar RS232Nr = 1;
//2 => no parity

static struct {
  unsigned short Baud;
  uchar Data, Parity, Stop;
} Standard = {
  96, 8, 2, 1
};

static unsigned short MaxSendCount = 512;
static char SendPrefix[256] = "\377";
static unsigned short StartPos = 0;
static unsigned short MaxBlocks = 2;
static uchar VGALines = 25;
static uchar IRQNum = 4;

static uchar EditAttr = 0x1f;
static boolean BackupOption = TRUE;

static char SerialDevice[256] = "/dev/cua2";

#ifdef WITH_X_COLORS

// black blue green cyan red khaki yellow white

static uchar VC[4][4] = {
  { 0x17, 0x1f, 0x17, 2 },
  { 0xc7, 0xcf, 0x47, 2 },
  { 0x02, 0x30, 0x03, 2 },
  { 0x30, 0x3e, 0x30, 2 }
};

static MenuInitRecType MenuInitRec[MaxMenu_] = {
//#1
  { 1, 1, 0x30, 0x37, 0x06, 0,
    " ~#  ~File  ~Edit  ~Options  ~Label  ~Terminal  ~Pass_One  ~Clear " },
//#2
  { 20, 7, 0x30, 0x01, 0x06, 8,
    "\n"
    " Universal Cross(:-) DisASsembler\n"
    "\n"
    "       by Thomas Pantzer\n"
    "           1992-1996\n"
    "\n"
    "\n"
    "              @ OK @ \n" },
//#3
  { 5, 3, 0x20, 0x27, 0x25, 8,
    " ~Load         @................@\n"
    " ~Save \n"
    " S~eek to:     @......@\n"
    " ~DownLoad at: @......@\n"
    " ~Receive to   @................@\n"
    " L~isting to:  @................@\n\n"
    " ~Abort " },
//#4    
  { 18, 3, 0x50, 0x5f, 0x51, 8,
    " ~Serial Parm's\n"
    " ~OpcodeDef. @................@\n"
    " Send~Count  @......@\n"
//    " ~BaseAdr.   @......@\n"
    " ~Burn EEProm\n"
    " ~Reset\n" 
    " S~aveOnExit @....@\n"},
//#5    
  { 1, 25, 0x30, 0x37, 0x3e, 0,
//    " Addr:  Lines:  Labels:  MemAvail: " },
    "Addr: @......@ Lines: @......@ Labels: @......@ BufSize: @......@ " },
//#6
  { 8, 7, 0x50, 0x57, 0x51, 8,
    " ~FileName   @................@\n"
    " ~Start at:  @0x0    @\n"
    " ~Blocks     @.......@\n\n"
    "    ~[~E~N~T~E~R~]    ~[~E~S~C~] " },
//#7    
  { 20, 6, 0x30, 0x70, 0x31, 8,
    " ~BaudDivisor @.....@\n"
    " ~DataBits    @....@\n"
    " ~Parity      @....@\n"
    " ~StopBits    @....@\n"
    " De~vice      @...........@\n"
    " De~faults\n"
    " ~Actuals     @...............@\n\n"
    "   ~ ~<~E~N~T~E~R~>~   ~ ~<~E~S~C~>~ " },
//#8    
  { 1, 1, 0x30, 0x0f, 0x0d, 0,
    " press <Alt+\"Key\">  ~Write  ~Receive  Deb~ug  R~eset  ~Init  Di~sassemble  ~F~1~0" },
//#9    
  { 27, 3, 0x30, 0x37, 0x31, 8,
    " ~Add\n"
    " ~Delete\n"
    " ~Edit\n"
    " define ~Table  length:@......@\n"
    " at Addr: @......@\n"
    " Name:    @............@\n"
    " ~NextNr:  @......@" }
};

#else

static uchar VC[4][4] = {
  { 0x17, 0x1f, 0x17, 2 },
  { 0xc7, 0xcf, 0x47, 3 },
  { 0x02, 0x30, 0x03, 4 },
  { 0x30, 0x3e, 0x30, 5 }
};

static MenuInitRecType MenuInitRec[MaxMenu_] = {
//#1
  { 1, 1, 0x70, 0x7f, 0xc, 0,
    " ~#  ~File  ~Edit  ~Options  ~Label  ~Terminal  ~Pass_One  ~Clear     " },
//#2
  { 20, 7, 0x70, 0x2f, 0xc, 8,
    "\n universal-Cross-DisAssembler\n       Thomas Pantzer\n\n\n            ~'~ ~ ~O~K~ \n" },
//#3
  { 5, 3, 0x70, 0x2f, 0x79, 8,
    " ~Load         @................@\n"
    " ~Save       \n"
    " S~eek to:     @......@\n"
    " ~DownLoad at: @......@\n"
    " ~Receive to   @................@\n"
    " L~isting to:  @................@\n\n"
    " ~Abort" },
//#4    
  { 18, 3, 0x70, 0x2f, 0x79, 8,
    " ~Serial Parm's\n"
    " ~EGALines\n"
    " ~OpcodeDef. @................@\n"
    " Send~Count  @......@\n"
    " ~BaseAdr.   @......@\n"
    " ~Reset " },
//#5    
  { 1, 25, 0x70, 0x7f, 0x7e, 0,
//    " Addr:  Lines:  Labels:  MemAvail: " },
    "Addr: @......@ Lines: @......@ Labels: @......@ BufSize: @......@ " },
//#6
  { 7, 6, 0x70, 0x1f, 0x79, 8,
    " ~FileName   @................@\n"
    " ~Start at:  @128    @\n"
    " ~Blocks     @.......@\n\n"
    "    ~ ~<~E~N~T~E~R~>~    ~~<~E~S~C~>~   " },
//#7    
  { 20, 6, 0x70, 0x2f, 0x79, 8,
    " ~BaudDivisor @.....@\n"
    " ~DataBits    @....@\n"
    " ~Parity      @....@\n"
    " ~StopBits    @....@\n"
    " De~faults\n"
    " ~Actuals     @...............@\n\n"
    "   ~ ~<~E~N~T~E~R~>~   ~ ~<~E~S~C~>~ " },
//#8    
  { 1, 1, 0x70, 0x1f, 0xc, 0,
    " press <Alt+\"Key\">  ~Write  ~Receive  Deb~ug  R~eset  ~Init  Di~sassemble  ~F~1~0" },
//#9    
  { 27, 3, 0x70, 0x2f, 0x79, 8,
    " ~Add\n"
    " ~Delete\n"
    " ~Edit\n"
    " define ~Table  length:@......@\n"
    " at Addr: @......@\n"
    " Name:     @............@\n"
    " ~NextNr:  @......@" }
};

#endif // WITH_X_COLORS


static char Msg[23][256] = {
  " disassembly ", 
  " Error ", 
  " Monitor ", 
  " diskwrite-error",
  " <Alt-X> = Halt", 
  " bytes", 
  " diskread-error", 
  " Send ", 
  " Received ",
  " in ", 
  "NR.", 
  " format error", 
  " already used  -  edit?\n", 
  " write error",
  " nothing to delete", 
  " nothing to edit  -  add?\n",
  "disassembling  Pass_One", 
  "reading opcode-definition-file", 
  " press a key",
  " Help-Window ", 
  " not updated  -  update?\n",
  " <Enter> = yes\n <ESC>   = no", 
  " BONEHEAD \n division by zero "
};


#ifndef LIBPATH
#define LIBPATH "/software/lib/ucdas/"
#endif


static char CdePath[256] = LIBPATH;


static char LstName[40] = "";
static char SymName[40] = "";
static char RcvName[40] = "";
static char CdeName[40] = "68HC11";
static char ObjName[40] = "boottst";
static char BakName[40] = "";

static char LstExt[40] = ".list";
static char SymExt[40] = ".symbols";
static char RcvExt[40] = ".recv";
static char CdeExt[40] = ".opcode";
static char ObjExt[40] = ".bin";
static char BakExt[40] = ".bak";


static char LastObject[256] = "./boottst.bin";
static char BinLoadPath[256] = "";

//________________________________ end Init _________________________________

static uchar configIndex3 = 'T';

